Attribute VB_Name = "General"
Public Declare Function DrawPicture Lib "msimg32.dll" Alias "TransparentBlt" (ByVal hDCDest As Long, ByVal XD As Long, ByVal YD As Long, ByVal WidthD As Long, ByVal HeightD As Long, ByVal hDCSource As Long, ByVal XS As Long, ByVal YS As Long, ByVal WS As Long, ByVal HS As Long, ByVal ColorTransparent As Long) As Long
Public Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal X As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Public Declare Function LockWindowUpdate Lib "user32" (ByVal hwndLock As Long) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function ReleaseCapture Lib "user32" () As Long
Public Declare Function SetCapture Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function GetCapture Lib "user32" () As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function TrackPopupMenu Lib "user32" (ByVal hMenu As Long, ByVal wFlags As Long, ByVal X As Long, ByVal y As Long, ByVal nReserved As Long, ByVal hWnd As Long, lprc As Long) As Long
Public Declare Function GetSystemMenu Lib "user32" (ByVal hWnd As Long, ByVal bRevert As Long) As Long
Public Declare Function UpdateWindow Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Sub CopyMemoryTo Lib "KERNEL32" Alias "RtlMoveMemory" (ByRef Destination As MINMAXINFO, ByVal Source As Long, ByVal Length As Long)
Public Declare Sub CopyMemoryFrom Lib "KERNEL32" Alias "RtlMoveMemory" (ByVal Destination As Long, ByRef Source As MINMAXINFO, ByVal Length As Long)

Public Const WM_NCLBUTTONDOWN = &HA1
Public Const HTCAPTION = &H2
Public Const GWL_STYLE = (-16)
Public Const WS_SYSMENU = &H80000
Public Const WS_MAXIMIZEBOX = &H10000
Public Const WS_MINIMIZEBOX = &H20000
Public Const WS_OVERLAPPED = &H0&
Public Const WS_THICKFRAME = &H40000
Public Const WS_BORDER = &H800000
Public Const WS_DLGFRAME = &H400000
Public Const WS_CAPTION = &HC00000
Public Const TPM_RIGHTBUTTON = &H2&
Public Const TPM_LEFTBUTTON = &H0&
Public Const GWL_WNDPROC = (-4)
Public Const WM_SYSCOMMAND = &H112
Public Const WM_COMMAND = &H111
Public Const WM_GETMINMAXINFO = &H24

Public Type POINTAPI
        X As Long
        y As Long
End Type

Public Type MINMAXINFO
        ptReserved As POINTAPI
        ptMaxSize As POINTAPI
        ptMaxPosition As POINTAPI
        ptMinTrackSize As POINTAPI
        ptMaxTrackSize As POINTAPI
End Type

Private MinMax As MINMAXINFO
Private WndProc As Long

Public Sub Subclass(ByVal hWnd As Long)
    WndProc = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf WindowProc)
End Sub

Public Sub UnSubclass()
    If WndProc <> 0 Then Call SetWindowLong(hWnd, GWL_WNDPROC, WndProc)
End Sub

Private Function WindowProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    
    Select Case uMsg

        Case WM_COMMAND
            uMsg = WM_SYSCOMMAND
            DoEvents
        
        Case WM_GETMINMAXINFO
            Call CopyMemoryTo(MinMax, lParam, Len(MinMax))
            MinMax.ptMinTrackSize.X = 380
            MinMax.ptMinTrackSize.y = 250
            Call CopyMemoryFrom(lParam, MinMax, Len(MinMax))
            Exit Function
            
    End Select
    
    WindowProc = CallWindowProc(WndProc, hWnd, uMsg, wParam, lParam)

End Function


